package gui_design_and_implimentation;

import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.util.Vector;

public class Main extends JApplet {

  BorderLayout borderLayout1 = new BorderLayout();

  JTabbedPane tabbedPane = new JTabbedPane();

  JPanel MemberInformation = new JPanel();
  JPanel AvailableLoanBooks = new JPanel();
  JPanel StaffInformation = new JPanel();

  XYLayout xYLayout1 = new XYLayout();
  XYLayout xYLayout2 = new XYLayout();
  XYLayout xYLayout3 = new XYLayout();

  PnlMember pnlMember = new PnlMember(this);
  PnlMemberBooks pnlMemberBooks = new PnlMemberBooks();
  PnlLibraryBooks pnlLibraryBooks = new PnlLibraryBooks(this);
  PnlAddLibraryBooks pnlAddLibraryBooks = new PnlAddLibraryBooks(this);

  PnlSelectMember pnlSelectMember = new PnlSelectMember(this);
  JButton btnPrintBook = new JButton();
  JButton btnBorrow = new JButton();
  JButton btnPrintMember = new JButton();


  public Main() {}

  public void init() {
    jbInit();
  }

  private void jbInit() {
    this.setSize(new Dimension(640, 480));
    this.getContentPane().setLayout(borderLayout1);
    this.getContentPane().setLayout(new BorderLayout());
    MemberInformation.setEnabled(true);
    MemberInformation.setDebugGraphicsOptions(0);
    MemberInformation.setDoubleBuffered(true);
    MemberInformation.setLayout(xYLayout1);
    AvailableLoanBooks.setLayout(xYLayout2);
    StaffInformation.setLayout(xYLayout3);
    btnPrintBook.setText("Print Current Book");
    btnPrintBook.addActionListener(new Main_btnPrintBook_actionAdapter(this));
    btnBorrow.setText("Borrow Book");
    btnBorrow.addActionListener(new Main_btnBorrow_actionAdapter(this));
    btnPrintMember.setText("Print Current Member");
    btnPrintMember.addActionListener(new Main_btnPrintMember_actionAdapter(this));
    this.getContentPane().add(tabbedPane, BorderLayout.CENTER);

//Members Information Tab
    tabbedPane.add(MemberInformation,         "Members Information");
    MemberInformation.add(pnlMemberBooks,     new XYConstraints(0, 305, 635, 149));
    MemberInformation.add(pnlMember,           new XYConstraints(0, 4, 635, 301));
//Available Loan Books Tab
    tabbedPane.add(AvailableLoanBooks,        "Library Books");
    AvailableLoanBooks.add(pnlLibraryBooks,   new XYConstraints(0, 198, 633, 232));
    AvailableLoanBooks.add(pnlSelectMember,   new XYConstraints(0, 0, 633, 197));
//Staff Information Tab
    tabbedPane.add(StaffInformation,          "Staff Managment");
    StaffInformation.add(pnlAddLibraryBooks,  new XYConstraints(0, 242, 630, 212));
    AvailableLoanBooks.add(btnBorrow,   new XYConstraints(326, 433, 163, 21));
    AvailableLoanBooks.add(btnPrintBook, new XYConstraints(0, 433, 163, 21));
    AvailableLoanBooks.add(btnPrintMember, new XYConstraints(163, 433, 163, 21));
  }

  public void addBook(Book book){
    pnlAddLibraryBooks.addBook(book);
    pnlLibraryBooks.addBook(book);
  }

  public void addMember(Member member){
    pnlMember.addMember(member);
    pnlSelectMember.addMember(member);
  }

  void btnPrintBook_actionPerformed(ActionEvent e) {
    Vector aBook = new Vector();
    aBook = pnlLibraryBooks.getBook();
    System.out.println(aBook);
  }

  void btnBorrow_actionPerformed(ActionEvent e) {
    Vector aBook = new Vector();
    aBook = pnlLibraryBooks.getBook();
    pnlSelectMember.getMember().add(aBook);
    Vector aMember = new Vector();
    aMember = pnlSelectMember.getMember();
    System.out.println(aMember);
  }

  void btnPrintMember_actionPerformed(ActionEvent e) {
    Vector aMember = new Vector();
    aMember = pnlSelectMember.getMember();
    System.out.println(aMember);

  }
}

class Main_btnPrintBook_actionAdapter implements java.awt.event.ActionListener {
  Main adaptee;

  Main_btnPrintBook_actionAdapter(Main adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnPrintBook_actionPerformed(e);
  }
}

class Main_btnBorrow_actionAdapter implements java.awt.event.ActionListener {
  Main adaptee;

  Main_btnBorrow_actionAdapter(Main adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnBorrow_actionPerformed(e);
  }
}

class Main_btnPrintMember_actionAdapter implements java.awt.event.ActionListener {
  Main adaptee;

  Main_btnPrintMember_actionAdapter(Main adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnPrintMember_actionPerformed(e);
  }
}
